﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlClient;
using System.Data;


/*
CREATE TABLE [dbo].[GV_T1](
	[Valor1] [nvarchar](50) NOT NULL,
	[Valor2] [int] NOT NULL,
	[Valor3] [datetime] NOT NULL,
	[Valor4] [bit] NOT NULL,
	[Valor5] [nvarchar](50) NOT NULL,
	[Valor6] [nvarchar](50) NOT NULL,
 CONSTRAINT [PK_GV_T1] PRIMARY KEY CLUSTERED 
(
	[Valor1] ASC,
	[Valor2] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]


INSERT INTO [{Base}].[dbo].[GV_T1]
           ([Valor1]
           ,[Valor2]
           ,[Valor3]
           ,[Valor4]
           ,[Valor5]
           ,[Valor6])
     VALUES
           ('A1' 
           ,1
           ,GETDATE()
           ,-1
           ,'Imagen1.gif'
           ,'~\Imagenes\imagen1.gif')
 

INSERT INTO [{Base}].[dbo].[GV_T1]
           ([Valor1]
           ,[Valor2]
           ,[Valor3]
           ,[Valor4]
           ,[Valor5]
           ,[Valor6])
     VALUES
           ('L1' 
           ,12
           ,GETDATE()
           ,-1
           ,'Imagen1.gif'
           ,'~\Imagenes\imagen1.gif')
           
INSERT INTO [{Base}].[dbo].[GV_T1]
           ([Valor1]
           ,[Valor2]
           ,[Valor3]
           ,[Valor4]
           ,[Valor5]
           ,[Valor6])
     VALUES
           ('M1' 
           ,13
           ,GETDATE()
           ,-1
           ,'Imagen1.gif'
           ,'~\Imagenes\imagen1.gif')
           
INSERT INTO [{Base}].[dbo].[GV_T1]
           ([Valor1]
           ,[Valor2]
           ,[Valor3]
           ,[Valor4]
           ,[Valor5]
           ,[Valor6])
     VALUES
           ('B1' 
           ,2
           ,GETDATE()
           ,-1
           ,'Imagen1.gif'
           ,'~\Imagenes\imagen1.gif')
           
           
INSERT INTO [{Base}].[dbo].[GV_T1]
           ([Valor1]
           ,[Valor2]
           ,[Valor3]
           ,[Valor4]
           ,[Valor5]
           ,[Valor6])
     VALUES
           ('C1' 
           ,3
           ,GETDATE()
           ,-1
           ,'Imagen1.gif'
           ,'~\Imagenes\imagen1.gif')

*/

namespace GVB
{
    public partial class SqlBinding : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack) ViewState["SortDirection"] = "ASC";
        }
        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);
            BindGrid(GV1);
        }
        protected void GV1_RowDeleting(object sender, GridViewDeleteEventArgs e)
        {
            GridView ctlGV = sender as GridView;
            using (SqlConnection SqlCn = new SqlConnection(System.Web.Configuration.WebConfigurationManager.ConnectionStrings["PAM"].ToString()))
            {
                using (SqlCommand SqlCmd = new SqlCommand("DELETE FROM GV_T1 WHERE Valor1 = @Valor1_original AND Valor2 = @Valor2_original", SqlCn))
                {
                    SqlCmd.Parameters.AddWithValue("Valor1_original", ctlGV.DataKeys[e.RowIndex].Values["Valor1"] as string);
                    SqlCmd.Parameters.AddWithValue("Valor2_original", (int)ctlGV.DataKeys[e.RowIndex].Values["Valor2"]);
                    SqlCmd.Connection.Open();
                    SqlCmd.ExecuteNonQuery();
                    SqlCmd.Connection.Close();
                }
            }

        }
        protected void GV1_RowEditing(object sender, GridViewEditEventArgs e)
        {
            (sender as GridView).EditIndex = e.NewEditIndex;
        }
        protected void GV1_RowUpdating(object sender, GridViewUpdateEventArgs e)
        {
            GridView ctlGV = sender as GridView;
            TextBox txtCol0_BoundField = ctlGV.Rows[e.RowIndex].Cells[0].Controls[0] as TextBox;
            TextBox txtCol1_ImageField = ctlGV.Rows[e.RowIndex].Cells[1].Controls[0] as TextBox;
            CheckBox txtCol2_CheckBoxField = ctlGV.Rows[e.RowIndex].Cells[2].Controls[0] as CheckBox;
            TextBox txtCol4_TemplateField_txtVV1 = ctlGV.Rows[e.RowIndex].Cells[4].FindControl("txtVV1") as TextBox;
            using (SqlConnection SqlCn = new SqlConnection(System.Web.Configuration.WebConfigurationManager.ConnectionStrings["PAM"].ToString()))
            {
                using (SqlCommand SqlCmd = new SqlCommand("UPDATE GV_T1 SET Valor1 = @Valor1, Valor4 = @Valor4,Valor5 = @Valor5 WHERE Valor1 = @Valor1_original AND Valor2 = @Valor2_original", SqlCn))
                {
                    SqlCmd.Parameters.AddWithValue("Valor4", txtCol2_CheckBoxField.Checked);
                    SqlCmd.Parameters.AddWithValue("Valor5", txtCol1_ImageField.Text);

                    if (string.Compare(txtCol0_BoundField.Text, txtCol4_TemplateField_txtVV1.Text) == 1)
                        SqlCmd.Parameters.AddWithValue("Valor1", txtCol4_TemplateField_txtVV1.Text);
                    else
                        SqlCmd.Parameters.AddWithValue("Valor1", txtCol0_BoundField.Text);

                    SqlCmd.Parameters.AddWithValue("Valor1_original", ctlGV.DataKeys[e.RowIndex].Values["Valor1"] as string);
                    SqlCmd.Parameters.AddWithValue("Valor2_original", (int)ctlGV.DataKeys[e.RowIndex].Values["Valor2"]);
                    SqlCmd.Connection.Open();
                    SqlCmd.ExecuteNonQuery();
                    SqlCmd.Connection.Close();
                }
            }
            (sender as GridView).EditIndex = -1;
        }
        protected void GV1_RowCancelingEdit(object sender, GridViewCancelEditEventArgs e)
        {
            (sender as GridView).EditIndex = -1;
        }

        protected void GV1_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            LblInfo.Text = "Comando: " + e.CommandName + " - Argumento: " + e.CommandArgument as string;
        }

        protected void GV1_Sorting(object sender, GridViewSortEventArgs e)
        {
            string strSortExpression = ViewState["SortExpression"] as string;
            string strSortDirection = ViewState["SortDirection"] as string;
            if (strSortExpression == e.SortExpression)
                strSortDirection = strSortDirection == "ASC" ? "DESC" : "ASC";
            else
                strSortDirection = "ASC";

            ViewState["SortExpression"] = e.SortExpression;
            ViewState["SortDirection"] = strSortDirection;
            //Deselección de item
            (sender as GridView).SelectedIndex = -1;
        }

        protected void GV1_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
            ViewState["PageIndex"] = e.NewPageIndex;
            //Deselección de item
            (sender as GridView).SelectedIndex = -1;
        }

        private void BindGrid(GridView Grd)
        {
            string strSortExpression = ViewState["SortExpression"] as string;
            string strSortDirection = ViewState["SortDirection"] as string;
            int? intPageIndex = ViewState["PageIndex"] as int?;
            string strCmdText = "SELECT * FROM GV_T1";
            if (!string.IsNullOrEmpty(strSortExpression))
                strCmdText = string.Format("SELECT * FROM GV_T1 ORDER BY {0} {1}", strSortExpression, strSortDirection);
            if (intPageIndex.HasValue)
                Grd.PageIndex = intPageIndex.Value;

            using (SqlConnection SqlCn = new SqlConnection(System.Web.Configuration.WebConfigurationManager.ConnectionStrings["PAM"].ToString()))
            {
                using (SqlCommand SqlCmd = new SqlCommand(strCmdText, SqlCn))
                {
                    SqlCmd.Connection.Open();
                    SqlDataAdapter SqlDA = new SqlDataAdapter(SqlCmd);
                    DataSet DS = new DataSet();
                    SqlDA.Fill(DS, "T1_A");
                    Grd.DataSource = DS;
                    Grd.DataMember = "T1_A";
                    Grd.DataBind();
                    SqlCmd.Connection.Close();
                }
            }
        }

        protected void GV1_SelectedIndexChanged(object sender, EventArgs e)
        {
            GridView ctlGV = sender as GridView;
            LblInfo.Text += " - Indice: " + ctlGV.SelectedIndex.ToString() + " - DataKey: " + ctlGV.SelectedDataKey["Valor2"] as string + "," + ctlGV.SelectedDataKey["Valor1"] as string;
        }
    }
}